//
// Nodes.h
//
#ifndef _NODES_H_
#define _NODES_H_

//
// Forward definitions
//
class VariableStruct;

//
// Main structure defining the program
//
class Node
{
private:
	int Type;		// Node Type
	char *TextValue;	// Text value associated with node
	Node *Down;		// Down pointer
	Node *Tree[4];		// Pointers to other nodes
	static int Level;	// Indentation level
	int FromInclude;	// Is this from an include file?

public:
	Node(int TypeValue = 0, char *TextValue = NULL, int Include = 0);
	~Node();

	Node* GetDown() { return Down; }
	int GetType() { return Type; }
	char* GetText() { return TextValue; }
	Node* GetTree(int Ptr) { return Tree[Ptr]; }

	void SetType(int NewType) { Type = NewType; }
				// Change this nodes type
	void SetInclude(int NewValue) { FromInclude = NewValue; }
	Node *Link(
		struct Node *Node0 = NULL, struct Node *Node1 = NULL,
		struct Node *Node2 = NULL, struct Node *Node3 = NULL);
				// Attach parameter nodes to main node
	Node *DownLink(struct Node *Node0);
				// Attach links at same level
	void UnDownLink() { Down = NULL; }
				// Attach links at same level
	void PrintTree(char* Level = "", int flag = 0, char Node = '*');
	void VariableScan(int AFlag);
	void VariableScanOne(int AFlag);
	int ScanType();
	void Output();
	void OutputCode();
	void OutputCodeOne();
	void OutputCodeNoParen();

private:
	void OutputBlock();
	void OutputPrint();
	void OutputInput();
	int OutputIPData(int InputFlag);
	void OutputData();
	void OutputDataValue();
	void OutputRead();
	void OutputMap();
	void OutputOneMap(VariableStruct* MapVar);
	void ScanMap();
	void ScanOneMap(VariableStruct* MapVar);
	void OutputCaseLabel();
	void OutputVarName();
	void Indent();
	void ScanVarList(int ThisType, int ThisClass, int Status);
	void DoRemark();
	void OutputDatatype(int ThisType);
	void OutputLabel();
	void OutputOngo(const char* GoType, int GoLevel);
	void OutputDefinition(Node* MainType, int ExtType);
	void OutputRecord();
	void OutputArrayParam();
	void OutputClose();
	void OutputOpenStuff(Node* Channel);
};

Node* ScanForLoops(Node* Program);

#endif
